﻿// Ten kod ActionScript 2.0 musi być umieszczony w zewnętrznym pliku Transform.as.

class Transform {
  // NEG_TRANS odwraca wartości kolorów.
  // NEUTRAL_TRANS przywraca wartości kolorów.
  // BLACK_TRANS określa czarne wartości kolorów.
  // WHITE_TRANS określa białe wartości kolorów.
  // RATE określa prędkość w milisekundach, z jaką odtwarzany będzie efekt.
	private static var NEG_TRANS:Object = {ra:-100, rb:255, ga:-100, gb:255, ba:-100, bb:255, aa:100, ab:0};
	private static var NEUTRAL_TRANS:Object = {ra:100, rb:0, ga:100, gb:0, ba:100, bb:0, aa:100, ab:0};
	private static var BLACK_TRANS:Object = {ra:100, rb:-255, ga:100, gb:-255, ba:100, bb:-255, aa:100, ab:0};
	private static var WHITE_TRANS:Object = {ra:100, rb:255, ga:100, gb:255, ba:100, bb:255, aa:100, ab:0};
	private static var RATE:Number = 50;
	private var interval:Number;
	private var startTime:Number;
	private var colorObj:Color;
  // Konstruktor akceptuje klip docelowy, w którym zastosowane
  // zostanie przekształcenie.
	public function Transform(targetClip:MovieClip) {
		colorObj = new Color(targetClip);
	}
	// Odwraca wartości kolorów.
	public function invert():Void {
		colorObj.setTransform(NEG_TRANS);
	}
	// Przywraca kolorom wartości domyślne określone w środowisku roboczym.
	public function reset():Void {
		colorObj.setTransform(NEUTRAL_TRANS);
	}
	// Wykonuje ściemnienie w określonym czasie (w ms).
	public function fadeToBlack(duration:Number):Void {
		applyTransform(BLACK_TRANS, duration);
	}
	// Wykonuje rozjaśnienie w określonym czasie (w ms).
	public function fadeToWhite(duration:Number):Void {
		applyTransform(WHITE_TRANS, duration);
	}
  // Funkcja inicjująca efekt zanikania oraz określająca interwał
  // zakończenia efektu.
	private function applyTransform(transObject:Object, duration:Number):Void {
		var getTrans:Object = colorObj.getTransform();
		var diffTrans:Object = new Object();
		startTime = getTimer();
		for (var i in transObject) {
			diffTrans[i] = (transObject[i]-getTrans[i])/(duration/RATE);
		}
    // Użyj formy wywołania funkcji setInterval( ), w którym parametrem jest metoda obiektu,
    // aby właściwości instancji były w zasięgu deklaracji (obiektem jest this).
    // Pierwszym parametrem jest obiekt (this), w stosunku do którego zostanie
    // wywołana metoda określona przez drugi parametr (o nazwie "transition",
    // który musi zostać przekazany jako wartość łańcuchowa).
    // Trzeci parametr jest interwałem mierzonym w milisekundach.
    // Parametry czwarty, piąty i szósty są przekazywane do funkcji transition().

		interval = setInterval(this, "transition", RATE, transObject, diffTrans, duration);
	}
	// Ta metoda wykonuje każdy etap transformacji kolorystycznej.
	private function transition(transObject:Object, diffTrans:Object, duration:Number):Void {
		var getTrans:Object = colorObj.getTransform();
		for (var i in diffTrans) {
			getTrans[i] += diffTrans[i];
		}
		colorObj.setTransform(getTrans);
		if (getTimer()-startTime>duration) {
			// Zakończ ostatni etap przekształcenia.
			colorObj.setTransform(transObject);
			// Wyczyść interwał, aby zatrzymać efekt.
			clearInterval(interval);
		}
		// Wymuś odświeżanie ekranu między klatkami.
		updateAfterEvent();
	}
	public function die():Void {
		// Wykonaj umieszczony tu kod czyszczący.
	}
}
